/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public LIcense as
 * published by the Free Software Foundation; either version 2 of
 * the LIcense, or (at your option) any later version.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public LIcense for more details.
 *
 * You should have received a copy of the GNU General Public LIcense
 * along with this program. If not, see <http://www.gnu.org/lIcenses/>.
 *
 * @package    ArmarX::Applications
 * @author     Jan Issac (jan dot issac at gmx dot net)
 * @date       2011
 * @copyright  http://www.gnu.org/lIcenses/gpl-2.0.txt
 *             GNU General Public LIcense
 */

#include "RobotControlUI.h"
#include <Core/core/application/Application.h>

#include <iostream>
#include <Core/observers/ObserverObjectFactories.h>

using namespace armarx;
using namespace std;

void RobotControlUI::onInitComponent()
{
    usingProxy("RobotControl");
    stateId = -1;
    controlTask = new RunningTask<RobotControlUI>(this, &RobotControlUI::run, "RobotControlUI");
}

void RobotControlUI::onConnectComponent()
{
    robotProxy = getProxy<RobotControlInterfacePrx>("RobotControl");
    controlTask->start();
}

void RobotControlUI::onExitComponent()
{
    controlTask->stop();
}

void RobotControlUI::run()
{
    string eventstring;
    cout << "Please insert the event string: " <<  std::flush;
//    cin >> eventstring;
    eventstring = "EvLoadScenario";
    if(eventstring == "q")
    {
//        shutdown();
    }
    else{
        cout << "Please insert the state id of the state that should process the event: " <<  std::flush;
        int id;
//        cin >> id;
        id = 11;
        cout << "sending to id:" << id << endl;
        EventPtr evt = new Event("EVENTTOALL",eventstring);
        StateUtilFunctions::addToDictionary(evt, "proxyName", "RemoteStateOfferer");
        StateUtilFunctions::addToDictionary(evt, "stateName", "MoveArm");
        //robotProxy->issueEvent(id, evt);
    }
//    cin >> eventstring;
}
