/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public LIcense as
 * published by the Free Software Foundation; either version 2 of
 * the LIcense, or (at your option) any later version.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public LIcense for more details.
 *
 * You should have received a copy of the GNU General Public LIcense
 * along with this program. If not, see <http://www.gnu.org/lIcenses/>.
 *
 * @package    ArmarX::Applications
 * @author     Jan Issac (jan dot issac at gmx dot net)
 * @date       2011
 * @copyright  http://www.gnu.org/lIcenses/gpl-2.0.txt
 *             GNU General Public LIcense
 */

#ifndef _ARMARX_SIMPLECOMPONENTTEST_H
#define _ARMARX_SIMPLECOMPONENTTEST_H

// ArmarXCore
#include <Core/core/Component.h>
#include <Core/core/services/tasks/RunningTask.h>
#include <Core/core/IceManager.h>
#include <RobotAPI/operations/RobotControl.h>
#include <string>

namespace armarx
{
    class RobotControlUI :
        virtual public Component
    {
    public:
        int stateId;
        RobotControlInterfacePrx robotProxy;
        virtual std::string getDefaultName() const { return "RobotControlUI"; }
        virtual void onInitComponent();
        virtual void onConnectComponent();
        virtual void onExitComponent();
        void run();
    private:
        RunningTask<RobotControlUI>::pointer_type controlTask;
    };
}

#endif
