/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    Armar4::units
 * @author     Peter Kaiser <peter dot kaiser at kit dot edu>
 * @date       2014
 * @copyright  http://www.gnu.org/licenses/gpl.txt
 *             GNU General Public License
 */

#ifndef ARMAR4_FT_UNIT_ARMAR4_H
#define ARMAR4_FT_UNIT_ARMAR4_H

#include <RobotAPI/units/HapticUnit.h>
//#include <Core/interface/units/
#include <Core/core/system/ImportExportComponent.h>

#include <string>
#include "WeissHapticSensor.h"

namespace armarx
{
    class WeissHapticSensorsUnitPropertyDefinitions : public HapticUnitPropertyDefinitions
    {
        public:
            WeissHapticSensorsUnitPropertyDefinitions(std::string prefix):
                HapticUnitPropertyDefinitions(prefix)
            {
                //defineOptionalProperty<int>("FirstPipeID", 1, "Id of the first Linux/Xenomai Pipe to use for data transfer");
                //defineOptionalProperty<std::string>("PipeBaseName", "rtp", "Base name of pipe devices");
                //defineOptionalProperty<std::string>("Logfile", "", "Logfile for logging pipe communication");
            }
    };
    
    class WeissHapticSensorsUnit : virtual public HapticUnit
    {
        public:
            virtual std::string getDefaultName() { return "HapticUnitArmar4"; }
            
            virtual void onInitHapticUnit();
            virtual void onStartHapticUnit();
            virtual void onExitHapticUnit();
            
            //virtual void onConnectComponent();
            virtual void onDisconnectComponent();
            
            virtual PropertyDefinitionsPtr createPropertyDefinitions();
            
        protected:
            //void proceedSensorCategory(SensorCategoryDefinition<MatrixFloat> *category);

            //std::map<std::string, MatrixFloatPtr> currentValues;
            

            
            //HapticSensorProtocolMaster hapticProtocol;

            //bool remoteSystemReady;

    private:
            std::vector< std::string > getDevices();

            std::vector< boost::shared_ptr< WeissHapticSensor > > sensors;
    };
}
    
#endif
